vexpower_panelText_editmode = false

function vexpower_panelText_testmode()
	vexpower_panelText_testmodeNuke()
	
	if vexpower_panelText_editmode then
		vexpower_panelText_testmodeGenerate()
	end
end

function vexpower_panelText_testmodeGenerate()
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_parameters["frame"]["energy"]["text"][key] ~= nil then
			if vexpower_energytext_TestFrames == nil then
				vexpower_energytext_TestFrames = {}
			end
			if vexpower_energytext_TestFramesText == nil then
				vexpower_energytext_TestFramesText = {}
			end
			
			--Frame
			vexpower_energytext_TestFrames[key] = CreateFrame("Frame", nil, vexpower_energybarbg)
			vexpower_energytext_TestFrames[key]:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
			vexpower_energytext_TestFrames[key]:SetBackdropColor(1, 1, 1, 1)
			vexpower_energytext_TestFrames[key]:SetBackdropBorderColor(1,0,0,1)
			vexpower_energytext_TestFrames[key]:SetWidth(vexpower_parameters["frame"]["energy"]["text"][key]["width"])
			vexpower_energytext_TestFrames[key]:SetHeight(vexpower_parameters["frame"]["energy"]["text"][key]["size"])
			vexpower_energytext_TestFrames[key]:SetFrameStrata("HIGH")
			vexpower_energytext_TestFrames[key]:ClearAllPoints()
			vexpower_energytext_TestFrames[key]:SetPoint(
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor"],
				"vexpower_energyTextbar",
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"],
				vexpower_parameters["frame"]["energy"]["text"][key]["x"],
				vexpower_parameters["frame"]["energy"]["text"][key]["y"])
			
			vexpower_energytext_TestFrames[key]:RegisterForDrag("LeftButton")
			vexpower_energytext_TestFrames[key]:SetScript("OnDragStart", function ()
				vexpower_energytext_TestFrames[key]:StartMoving()
				end)
			vexpower_energytext_TestFrames[key]:SetScript("OnDragStop", function (self)
				self:StopMovingOrSizing()
				local x1, y1 = self:GetLeft(), self:GetTop()
				local x2, y2 = self:GetParent():GetLeft(), self:GetParent():GetTop()
				self:ClearAllPoints()
				self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", x1 - x2, y1 - y2)
				vexpower_saveTextfieldPos(key)
				vexpower_setFontStrings()
				end)
			vexpower_energytext_TestFrames[key]:EnableMouse(true)
			vexpower_energytext_TestFrames[key]:SetMovable(true)
			
			
			--FontString
			vexpower_energytext_TestFramesText[key] = vexpower_energytext_TestFrames[key]:CreateFontString("vexpower_energytext_TestFramesText["..key.."]", "OVERLAY", "GameFontNormal")
			vexpower_energytext_TestFramesText[key]:Show()
			vexpower_energytext_TestFramesText[key]:ClearAllPoints()
			vexpower_energytext_TestFramesText[key]:SetPoint("CENTER", vexpower_energytext_TestFrames[key], "CENTER", 0, 0)
			vexpower_energytext_TestFramesText[key]:SetTextColor(vexpower_parameters["frame"]["energy"]["text"][key]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["a"])
			vexpower_energytext_TestFramesText[key]:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"][key]["font"]),
											vexpower_parameters["frame"]["energy"]["text"][key]["size"],
											vexpower_parameters["frame"]["energy"]["text"][key]["effect"])	
			vexpower_energytext_TestFramesText[key]:SetWidth(vexpower_parameters["frame"]["energy"]["text"][key]["width"])	
			vexpower_energytext_TestFramesText[key]:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"][key]["align"])
			if vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["allow"] then	
				vexpower_energytext_TestFramesText[key]:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["a"])
				vexpower_energytext_TestFramesText[key]:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["offset"]["x"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["offset"]["y"])
			else
				vexpower_energytext_TestFramesText[key]:SetShadowColor(0, 0, 0, 0)
				vexpower_energytext_TestFramesText[key]:SetShadowOffset(0, 0)
			end
			vexpower_energytext_TestFramesText[key]:SetText(vexpower_parseTagInfo(vexpower_parameters["frame"]["energy"]["text"][key]["text"]))
		end
	end
end

function vexpower_panelText_testmodeNuke()
	if vexpower_energytext_TestFrames~= nil then
		for key in pairs(vexpower_energytext_TestFrames) do
			if vexpower_energytext_TestFrames[key]~= nil then
				vexpower_energytext_TestFrames[key]:Hide()
				vexpower_energytext_TestFrames[key] = nil
			end
		end
	end
end

function vexpower_saveTextfieldPos(key)
	vexpower_parameters["frame"]["energy"]["text"][key]["anchor"] =  select(1, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"] =  select(3, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["x"] =  select(4, vexpower_energytext_TestFrames[key]:GetPoint())-vexpower_parameters["frame"]["energy"]["border"]["size"]
	vexpower_parameters["frame"]["energy"]["text"][key]["y"] =  select(5, vexpower_energytext_TestFrames[key]:GetPoint())+vexpower_parameters["frame"]["energy"]["border"]["size"]
end